<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfGemeindeBetriebNummernblock ArrayType
 * @subpackage Arrays
 */
class ArrayOfGemeindeBetriebNummernblock extends AbstractStructArrayBase
{
    /**
     * The nummernblock
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\Nummernblock[]
     */
    public $nummernblock;
    /**
     * Constructor method for ArrayOfGemeindeBetriebNummernblock
     * @uses ArrayOfGemeindeBetriebNummernblock::setNummernblock()
     * @param \StructType\Nummernblock[] $nummernblock
     */
    public function __construct(array $nummernblock = array())
    {
        $this
            ->setNummernblock($nummernblock);
    }
    /**
     * Get nummernblock value
     * @return \StructType\Nummernblock[]|null
     */
    public function getNummernblock()
    {
        return $this->nummernblock;
    }
    /**
     * This method is responsible for validating the values passed to the setNummernblock method
     * This method is willingly generated in order to preserve the one-line inline validation within the setNummernblock method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateNummernblockForArrayConstraintsFromSetNummernblock(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfGemeindeBetriebNummernblockNummernblockItem) {
            // validation for constraint: itemType
            if (!$arrayOfGemeindeBetriebNummernblockNummernblockItem instanceof \StructType\Nummernblock) {
                $invalidValues[] = is_object($arrayOfGemeindeBetriebNummernblockNummernblockItem) ? get_class($arrayOfGemeindeBetriebNummernblockNummernblockItem) : sprintf('%s(%s)', gettype($arrayOfGemeindeBetriebNummernblockNummernblockItem), var_export($arrayOfGemeindeBetriebNummernblockNummernblockItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The nummernblock property can only contain items of type \StructType\Nummernblock, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set nummernblock value
     * @throws \InvalidArgumentException
     * @param \StructType\Nummernblock[] $nummernblock
     * @return \ArrayType\ArrayOfGemeindeBetriebNummernblock
     */
    public function setNummernblock(array $nummernblock = array())
    {
        // validation for constraint: array
        if ('' !== ($nummernblockArrayErrorMessage = self::validateNummernblockForArrayConstraintsFromSetNummernblock($nummernblock))) {
            throw new \InvalidArgumentException($nummernblockArrayErrorMessage, __LINE__);
        }
        $this->nummernblock = $nummernblock;
        return $this;
    }
    /**
     * Add item to nummernblock value
     * @throws \InvalidArgumentException
     * @param \StructType\Nummernblock $item
     * @return \ArrayType\ArrayOfGemeindeBetriebNummernblock
     */
    public function addToNummernblock(\StructType\Nummernblock $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Nummernblock) {
            throw new \InvalidArgumentException(sprintf('The nummernblock property can only contain items of type \StructType\Nummernblock, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->nummernblock[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\Nummernblock|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\Nummernblock|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\Nummernblock|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\Nummernblock|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\Nummernblock|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string nummernblock
     */
    public function getAttributeName()
    {
        return 'nummernblock';
    }
}
