<?php
/**
 * Class which returns the class map definition
 * @package
 */
class ClassMap
{
    /**
     * Returns the mapping between the WSDL Structs and generated Structs' classes
     * This array is sent to the \SoapClient when calling the WS
     * @return string[]
     */
    final public static function get()
    {
        return array(
            'ProcessInsertedData' => '\\StructType\\ProcessInsertedData',
            'ProcessInsertedDataResponse' => '\\StructType\\ProcessInsertedDataResponse',
            'ProcessInsertedVRData' => '\\StructType\\ProcessInsertedVRData',
            'ProcessInsertedVRDataResponse' => '\\StructType\\ProcessInsertedVRDataResponse',
            'ShowStatusVRTransfer' => '\\StructType\\ShowStatusVRTransfer',
            'ShowStatusVRTransferResponse' => '\\StructType\\ShowStatusVRTransferResponse',
            'ResetVRTransfer' => '\\StructType\\ResetVRTransfer',
            'ResetVRTransferResponse' => '\\StructType\\ResetVRTransferResponse',
            'ForceNewProcessOfVRImportErrorData' => '\\StructType\\ForceNewProcessOfVRImportErrorData',
            'ForceNewProcessOfVRImportErrorDataResponse' => '\\StructType\\ForceNewProcessOfVRImportErrorDataResponse',
            'ProcessOfVRImportErrors' => '\\StructType\\ProcessOfVRImportErrors',
            'ProcessOfVRImportErrorsResponse' => '\\StructType\\ProcessOfVRImportErrorsResponse',
            'ProcessOfVRImportError' => '\\StructType\\ProcessOfVRImportError',
            'ProcessOfVRImportErrorResponse' => '\\StructType\\ProcessOfVRImportErrorResponse',
            'ReProcessOfImportErrorsWithTimeout' => '\\StructType\\ReProcessOfImportErrorsWithTimeout',
            'ReProcessOfImportErrorsWithTimeoutResponse' => '\\StructType\\ReProcessOfImportErrorsWithTimeoutResponse',
            'ProcessXMLImportEntry' => '\\StructType\\ProcessXMLImportEntry',
            'ProcessXMLImportEntryResponse' => '\\StructType\\ProcessXMLImportEntryResponse',
            'ForceNewProcessOfVRXMLImportDataWithStatusError' => '\\StructType\\ForceNewProcessOfVRXMLImportDataWithStatusError',
            'ForceNewProcessOfVRXMLImportDataWithStatusErrorResponse' => '\\StructType\\ForceNewProcessOfVRXMLImportDataWithStatusErrorResponse',
            'ProcessInsertedScannerData' => '\\StructType\\ProcessInsertedScannerData',
            'ProcessInsertedScannerDataResponse' => '\\StructType\\ProcessInsertedScannerDataResponse',
            'ProcessInsertedVT_KWTData' => '\\StructType\\ProcessInsertedVT_KWTData',
            'ProcessInsertedVT_KWTDataResponse' => '\\StructType\\ProcessInsertedVT_KWTDataResponse',
            'ProcessOfInternalInsertedXMLImport' => '\\StructType\\ProcessOfInternalInsertedXMLImport',
            'ProcessOfInternalInsertedXMLImportResponse' => '\\StructType\\ProcessOfInternalInsertedXMLImportResponse',
            'RealProcessOfInternalInsertedXMLImports' => '\\StructType\\RealProcessOfInternalInsertedXMLImports',
            'RealProcessOfInternalInsertedXMLImportsResponse' => '\\StructType\\RealProcessOfInternalInsertedXMLImportsResponse',
            'answer' => '\\StructType\\Answer',
            'error' => '\\StructType\\Error',
            'warnung' => '\\StructType\\Warnung',
            'Login' => '\\StructType\\Login',
            'LoginResponse' => '\\StructType\\LoginResponse',
            'PMSAutoAssignVTBlock' => '\\StructType\\PMSAutoAssignVTBlock',
            'PMSAutoAssignVTBlockResponse' => '\\StructType\\PMSAutoAssignVTBlockResponse',
            'GetVTInfo' => '\\StructType\\GetVTInfo',
            'GetVTInfoResponse' => '\\StructType\\GetVTInfoResponse',
            'ReProcessOfImportErrors' => '\\StructType\\ReProcessOfImportErrors',
            'ReProcessOfImportErrorsResponse' => '\\StructType\\ReProcessOfImportErrorsResponse',
            'gemeinde' => '\\StructType\\Gemeinde',
            'betrieb' => '\\StructType\\Betrieb',
            'meldeblatt' => '\\StructType\\Meldeblatt',
            'gastartlist' => '\\StructType\\Gastartlist',
            'gastart' => '\\StructType\\Gastart',
            'card' => '\\StructType\\Card',
            'webclient' => '\\StructType\\Webclient',
            'precheckin' => '\\StructType\\Precheckin',
            'selfcheckin' => '\\StructType\\Selfcheckin',
            'anreisetyp' => '\\StructType\\Anreisetyp',
            'aufenthaltsmotiv' => '\\StructType\\Aufenthaltsmotiv',
            'gast' => '\\StructType\\Gast',
            'hobby' => '\\StructType\\Hobby',
            'landschl' => '\\StructType\\Landschl',
            'resonanz' => '\\StructType\\Resonanz',
            'ArrayOfGemeindeBetriebNummernblock' => '\\ArrayType\\ArrayOfGemeindeBetriebNummernblock',
            'nummernblock' => '\\StructType\\Nummernblock',
            'VTFormXml' => '\\StructType\\VTFormXml',
            'BaseObject' => '\\StructType\\BaseObject',
            'GetVTInfoResult' => '\\StructType\\GetVTInfoResult',
            'PMSAutoAssignVTBlockResult' => '\\StructType\\PMSAutoAssignVTBlockResult',
            'ResponseType' => '\\StructType\\ResponseType',
            'ServiceProviderVTBlocksType' => '\\StructType\\ServiceProviderVTBlocksType',
            'AssignedVTBlockType' => '\\StructType\\AssignedVTBlockType',
            'AutoAssignedVTBlockType' => '\\StructType\\AutoAssignedVTBlockType',
            'ClosedPeriodsType' => '\\StructType\\ClosedPeriodsType',
            'ClosedPeriodType' => '\\StructType\\ClosedPeriodType',
            'CommunityList' => '\\StructType\\CommunityList',
            'CommunityType' => '\\StructType\\CommunityType',
            'ArrayOfServiceProviderType' => '\\ArrayType\\ArrayOfServiceProviderType',
            'ServiceProviderType' => '\\StructType\\ServiceProviderType',
            'ArrayOfPersonGroupType' => '\\ArrayType\\ArrayOfPersonGroupType',
            'PersonGroupType' => '\\StructType\\PersonGroupType',
            'VTServiceProviderList' => '\\StructType\\VTServiceProviderList',
            'VTServiceProviderType' => '\\StructType\\VTServiceProviderType',
            'SettlementSPList' => '\\StructType\\SettlementSPList',
            'SPSettlementType' => '\\StructType\\SPSettlementType',
            'VTCategoryList' => '\\StructType\\VTCategoryList',
            'VTCategoryType' => '\\StructType\\VTCategoryType',
            'VTCountryList' => '\\StructType\\VTCountryList',
            'VTCountryType' => '\\StructType\\VTCountryType',
            'VTInventoryList' => '\\StructType\\VTInventoryList',
            'VTInventoryType' => '\\StructType\\VTInventoryType',
            'VTPriceType' => '\\StructType\\VTPriceType',
            'TariffType' => '\\StructType\\TariffType',
            'FeratelDsiRS' => '\\StructType\\FeratelDsiRS',
        );
    }
}
