<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for gastartlist StructType
 * @subpackage Structs
 */
class Gastartlist extends AbstractStructBase
{
    /**
     * The AlterTaggenau
     * Meta information extracted from the WSDL
     * - use: required
     * @var bool
     */
    public $AlterTaggenau;
    /**
     * The gastart
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\Gastart[]
     */
    public $gastart;
    /**
     * Constructor method for gastartlist
     * @uses Gastartlist::setAlterTaggenau()
     * @uses Gastartlist::setGastart()
     * @param bool $alterTaggenau
     * @param \StructType\Gastart[] $gastart
     */
    public function __construct($alterTaggenau = null, array $gastart = array())
    {
        $this
            ->setAlterTaggenau($alterTaggenau)
            ->setGastart($gastart);
    }
    /**
     * Get AlterTaggenau value
     * @return bool
     */
    public function getAlterTaggenau()
    {
        return $this->AlterTaggenau;
    }
    /**
     * Set AlterTaggenau value
     * @param bool $alterTaggenau
     * @return \StructType\Gastartlist
     */
    public function setAlterTaggenau($alterTaggenau = null)
    {
        // validation for constraint: boolean
        if (!is_null($alterTaggenau) && !is_bool($alterTaggenau)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($alterTaggenau, true), gettype($alterTaggenau)), __LINE__);
        }
        $this->AlterTaggenau = $alterTaggenau;
        return $this;
    }
    /**
     * Get gastart value
     * @return \StructType\Gastart[]|null
     */
    public function getGastart()
    {
        return $this->gastart;
    }
    /**
     * This method is responsible for validating the values passed to the setGastart method
     * This method is willingly generated in order to preserve the one-line inline validation within the setGastart method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateGastartForArrayConstraintsFromSetGastart(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $gastartlistGastartItem) {
            // validation for constraint: itemType
            if (!$gastartlistGastartItem instanceof \StructType\Gastart) {
                $invalidValues[] = is_object($gastartlistGastartItem) ? get_class($gastartlistGastartItem) : sprintf('%s(%s)', gettype($gastartlistGastartItem), var_export($gastartlistGastartItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The gastart property can only contain items of type \StructType\Gastart, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set gastart value
     * @throws \InvalidArgumentException
     * @param \StructType\Gastart[] $gastart
     * @return \StructType\Gastartlist
     */
    public function setGastart(array $gastart = array())
    {
        // validation for constraint: array
        if ('' !== ($gastartArrayErrorMessage = self::validateGastartForArrayConstraintsFromSetGastart($gastart))) {
            throw new \InvalidArgumentException($gastartArrayErrorMessage, __LINE__);
        }
        $this->gastart = $gastart;
        return $this;
    }
    /**
     * Add item to gastart value
     * @throws \InvalidArgumentException
     * @param \StructType\Gastart $item
     * @return \StructType\Gastartlist
     */
    public function addToGastart(\StructType\Gastart $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Gastart) {
            throw new \InvalidArgumentException(sprintf('The gastart property can only contain items of type \StructType\Gastart, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->gastart[] = $item;
        return $this;
    }
}
