<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for landschl StructType
 * @subpackage Structs
 */
class Landschl extends AbstractStructBase
{
    /**
     * The anzpers
     * Meta information extracted from the WSDL
     * - use: required
     * @var int
     */
    public $anzpers;
    /**
     * The lschlnr
     * @var string
     */
    public $lschlnr;
    /**
     * The feratelext_nights
     * Meta information extracted from the WSDL
     * - default: 0
     * @var int
     */
    public $feratelext_nights;
    /**
     * The land
     * @var string
     */
    public $land;
    /**
     * Constructor method for landschl
     * @uses Landschl::setAnzpers()
     * @uses Landschl::setLschlnr()
     * @uses Landschl::setFeratelext_nights()
     * @uses Landschl::setLand()
     * @param int $anzpers
     * @param string $lschlnr
     * @param int $feratelext_nights
     * @param string $land
     */
    public function __construct($anzpers = null, $lschlnr = null, $feratelext_nights = 0, $land = null)
    {
        $this
            ->setAnzpers($anzpers)
            ->setLschlnr($lschlnr)
            ->setFeratelext_nights($feratelext_nights)
            ->setLand($land);
    }
    /**
     * Get anzpers value
     * @return int
     */
    public function getAnzpers()
    {
        return $this->anzpers;
    }
    /**
     * Set anzpers value
     * @param int $anzpers
     * @return \StructType\Landschl
     */
    public function setAnzpers($anzpers = null)
    {
        // validation for constraint: int
        if (!is_null($anzpers) && !(is_int($anzpers) || ctype_digit($anzpers))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($anzpers, true), gettype($anzpers)), __LINE__);
        }
        $this->anzpers = $anzpers;
        return $this;
    }
    /**
     * Get lschlnr value
     * @return string|null
     */
    public function getLschlnr()
    {
        return $this->lschlnr;
    }
    /**
     * Set lschlnr value
     * @param string $lschlnr
     * @return \StructType\Landschl
     */
    public function setLschlnr($lschlnr = null)
    {
        // validation for constraint: string
        if (!is_null($lschlnr) && !is_string($lschlnr)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($lschlnr, true), gettype($lschlnr)), __LINE__);
        }
        $this->lschlnr = $lschlnr;
        return $this;
    }
    /**
     * Get feratelext_nights value
     * @return int|null
     */
    public function getFeratelext_nights()
    {
        return $this->feratelext_nights;
    }
    /**
     * Set feratelext_nights value
     * @param int $feratelext_nights
     * @return \StructType\Landschl
     */
    public function setFeratelext_nights($feratelext_nights = 0)
    {
        // validation for constraint: int
        if (!is_null($feratelext_nights) && !(is_int($feratelext_nights) || ctype_digit($feratelext_nights))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($feratelext_nights, true), gettype($feratelext_nights)), __LINE__);
        }
        $this->feratelext_nights = $feratelext_nights;
        return $this;
    }
    /**
     * Get land value
     * @return string|null
     */
    public function getLand()
    {
        return $this->land;
    }
    /**
     * Set land value
     * @param string $land
     * @return \StructType\Landschl
     */
    public function setLand($land = null)
    {
        // validation for constraint: string
        if (!is_null($land) && !is_string($land)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($land, true), gettype($land)), __LINE__);
        }
        $this->land = $land;
        return $this;
    }
}
