<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ProcessOfVRImportErrors StructType
 * @subpackage Structs
 */
class ProcessOfVRImportErrors extends AbstractStructBase
{
    /**
     * The ForceImportSettled
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $ForceImportSettled;
    /**
     * The ForceImportCancelled
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $ForceImportCancelled;
    /**
     * The commaSeparatedImportErrorGUIDs
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $commaSeparatedImportErrorGUIDs;
    /**
     * The LoginID
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $LoginID;
    /**
     * Constructor method for ProcessOfVRImportErrors
     * @uses ProcessOfVRImportErrors::setForceImportSettled()
     * @uses ProcessOfVRImportErrors::setForceImportCancelled()
     * @uses ProcessOfVRImportErrors::setCommaSeparatedImportErrorGUIDs()
     * @uses ProcessOfVRImportErrors::setLoginID()
     * @param bool $forceImportSettled
     * @param bool $forceImportCancelled
     * @param string $commaSeparatedImportErrorGUIDs
     * @param string $loginID
     */
    public function __construct($forceImportSettled = null, $forceImportCancelled = null, $commaSeparatedImportErrorGUIDs = null, $loginID = null)
    {
        $this
            ->setForceImportSettled($forceImportSettled)
            ->setForceImportCancelled($forceImportCancelled)
            ->setCommaSeparatedImportErrorGUIDs($commaSeparatedImportErrorGUIDs)
            ->setLoginID($loginID);
    }
    /**
     * Get ForceImportSettled value
     * @return bool
     */
    public function getForceImportSettled()
    {
        return $this->ForceImportSettled;
    }
    /**
     * Set ForceImportSettled value
     * @param bool $forceImportSettled
     * @return \StructType\ProcessOfVRImportErrors
     */
    public function setForceImportSettled($forceImportSettled = null)
    {
        // validation for constraint: boolean
        if (!is_null($forceImportSettled) && !is_bool($forceImportSettled)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($forceImportSettled, true), gettype($forceImportSettled)), __LINE__);
        }
        $this->ForceImportSettled = $forceImportSettled;
        return $this;
    }
    /**
     * Get ForceImportCancelled value
     * @return bool
     */
    public function getForceImportCancelled()
    {
        return $this->ForceImportCancelled;
    }
    /**
     * Set ForceImportCancelled value
     * @param bool $forceImportCancelled
     * @return \StructType\ProcessOfVRImportErrors
     */
    public function setForceImportCancelled($forceImportCancelled = null)
    {
        // validation for constraint: boolean
        if (!is_null($forceImportCancelled) && !is_bool($forceImportCancelled)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($forceImportCancelled, true), gettype($forceImportCancelled)), __LINE__);
        }
        $this->ForceImportCancelled = $forceImportCancelled;
        return $this;
    }
    /**
     * Get commaSeparatedImportErrorGUIDs value
     * @return string|null
     */
    public function getCommaSeparatedImportErrorGUIDs()
    {
        return $this->commaSeparatedImportErrorGUIDs;
    }
    /**
     * Set commaSeparatedImportErrorGUIDs value
     * @param string $commaSeparatedImportErrorGUIDs
     * @return \StructType\ProcessOfVRImportErrors
     */
    public function setCommaSeparatedImportErrorGUIDs($commaSeparatedImportErrorGUIDs = null)
    {
        // validation for constraint: string
        if (!is_null($commaSeparatedImportErrorGUIDs) && !is_string($commaSeparatedImportErrorGUIDs)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($commaSeparatedImportErrorGUIDs, true), gettype($commaSeparatedImportErrorGUIDs)), __LINE__);
        }
        $this->commaSeparatedImportErrorGUIDs = $commaSeparatedImportErrorGUIDs;
        return $this;
    }
    /**
     * Get LoginID value
     * @return string|null
     */
    public function getLoginID()
    {
        return $this->LoginID;
    }
    /**
     * Set LoginID value
     * @param string $loginID
     * @return \StructType\ProcessOfVRImportErrors
     */
    public function setLoginID($loginID = null)
    {
        // validation for constraint: string
        if (!is_null($loginID) && !is_string($loginID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($loginID, true), gettype($loginID)), __LINE__);
        }
        $this->LoginID = $loginID;
        return $this;
    }
}
