<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for RealProcessOfInternalInsertedXMLImports StructType
 * @subpackage Structs
 */
class RealProcessOfInternalInsertedXMLImports extends AbstractStructBase
{
    /**
     * The importType
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $importType;
    /**
     * The processAfterYear
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $processAfterYear;
    /**
     * The skipExistingVRs
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $skipExistingVRs;
    /**
     * The rowGuid
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $rowGuid;
    /**
     * The login
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $login;
    /**
     * Constructor method for RealProcessOfInternalInsertedXMLImports
     * @uses RealProcessOfInternalInsertedXMLImports::setImportType()
     * @uses RealProcessOfInternalInsertedXMLImports::setProcessAfterYear()
     * @uses RealProcessOfInternalInsertedXMLImports::setSkipExistingVRs()
     * @uses RealProcessOfInternalInsertedXMLImports::setRowGuid()
     * @uses RealProcessOfInternalInsertedXMLImports::setLogin()
     * @param int $importType
     * @param int $processAfterYear
     * @param bool $skipExistingVRs
     * @param string $rowGuid
     * @param string $login
     */
    public function __construct($importType = null, $processAfterYear = null, $skipExistingVRs = null, $rowGuid = null, $login = null)
    {
        $this
            ->setImportType($importType)
            ->setProcessAfterYear($processAfterYear)
            ->setSkipExistingVRs($skipExistingVRs)
            ->setRowGuid($rowGuid)
            ->setLogin($login);
    }
    /**
     * Get importType value
     * @return int
     */
    public function getImportType()
    {
        return $this->importType;
    }
    /**
     * Set importType value
     * @param int $importType
     * @return \StructType\RealProcessOfInternalInsertedXMLImports
     */
    public function setImportType($importType = null)
    {
        // validation for constraint: int
        if (!is_null($importType) && !(is_int($importType) || ctype_digit($importType))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($importType, true), gettype($importType)), __LINE__);
        }
        $this->importType = $importType;
        return $this;
    }
    /**
     * Get processAfterYear value
     * @return int
     */
    public function getProcessAfterYear()
    {
        return $this->processAfterYear;
    }
    /**
     * Set processAfterYear value
     * @param int $processAfterYear
     * @return \StructType\RealProcessOfInternalInsertedXMLImports
     */
    public function setProcessAfterYear($processAfterYear = null)
    {
        // validation for constraint: int
        if (!is_null($processAfterYear) && !(is_int($processAfterYear) || ctype_digit($processAfterYear))) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide an integer value, %s given', var_export($processAfterYear, true), gettype($processAfterYear)), __LINE__);
        }
        $this->processAfterYear = $processAfterYear;
        return $this;
    }
    /**
     * Get skipExistingVRs value
     * @return bool
     */
    public function getSkipExistingVRs()
    {
        return $this->skipExistingVRs;
    }
    /**
     * Set skipExistingVRs value
     * @param bool $skipExistingVRs
     * @return \StructType\RealProcessOfInternalInsertedXMLImports
     */
    public function setSkipExistingVRs($skipExistingVRs = null)
    {
        // validation for constraint: boolean
        if (!is_null($skipExistingVRs) && !is_bool($skipExistingVRs)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($skipExistingVRs, true), gettype($skipExistingVRs)), __LINE__);
        }
        $this->skipExistingVRs = $skipExistingVRs;
        return $this;
    }
    /**
     * Get rowGuid value
     * @return string|null
     */
    public function getRowGuid()
    {
        return $this->rowGuid;
    }
    /**
     * Set rowGuid value
     * @param string $rowGuid
     * @return \StructType\RealProcessOfInternalInsertedXMLImports
     */
    public function setRowGuid($rowGuid = null)
    {
        // validation for constraint: string
        if (!is_null($rowGuid) && !is_string($rowGuid)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($rowGuid, true), gettype($rowGuid)), __LINE__);
        }
        $this->rowGuid = $rowGuid;
        return $this;
    }
    /**
     * Get login value
     * @return string|null
     */
    public function getLogin()
    {
        return $this->login;
    }
    /**
     * Set login value
     * @param string $login
     * @return \StructType\RealProcessOfInternalInsertedXMLImports
     */
    public function setLogin($login = null)
    {
        // validation for constraint: string
        if (!is_null($login) && !is_string($login)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($login, true), gettype($login)), __LINE__);
        }
        $this->login = $login;
        return $this;
    }
}
