<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ServiceProviderType StructType
 * @subpackage Structs
 */
class ServiceProviderType extends AbstractStructBase
{
    /**
     * The ID
     * @var string
     */
    public $ID;
    /**
     * The Name
     * @var string
     */
    public $Name;
    /**
     * The Town
     * @var string
     */
    public $Town;
    /**
     * The Code
     * @var string
     */
    public $Code;
    /**
     * The Email1
     * @var string
     */
    public $Email1;
    /**
     * The Email2
     * @var string
     */
    public $Email2;
    /**
     * The Phone
     * @var string
     */
    public $Phone;
    /**
     * The Mobile
     * @var string
     */
    public $Mobile;
    /**
     * The Fax
     * @var string
     */
    public $Fax;
    /**
     * The URL
     * @var string
     */
    public $URL;
    /**
     * Constructor method for ServiceProviderType
     * @uses ServiceProviderType::setID()
     * @uses ServiceProviderType::setName()
     * @uses ServiceProviderType::setTown()
     * @uses ServiceProviderType::setCode()
     * @uses ServiceProviderType::setEmail1()
     * @uses ServiceProviderType::setEmail2()
     * @uses ServiceProviderType::setPhone()
     * @uses ServiceProviderType::setMobile()
     * @uses ServiceProviderType::setFax()
     * @uses ServiceProviderType::setURL()
     * @param string $iD
     * @param string $name
     * @param string $town
     * @param string $code
     * @param string $email1
     * @param string $email2
     * @param string $phone
     * @param string $mobile
     * @param string $fax
     * @param string $uRL
     */
    public function __construct($iD = null, $name = null, $town = null, $code = null, $email1 = null, $email2 = null, $phone = null, $mobile = null, $fax = null, $uRL = null)
    {
        $this
            ->setID($iD)
            ->setName($name)
            ->setTown($town)
            ->setCode($code)
            ->setEmail1($email1)
            ->setEmail2($email2)
            ->setPhone($phone)
            ->setMobile($mobile)
            ->setFax($fax)
            ->setURL($uRL);
    }
    /**
     * Get ID value
     * @return string|null
     */
    public function getID()
    {
        return $this->ID;
    }
    /**
     * Set ID value
     * @param string $iD
     * @return \StructType\ServiceProviderType
     */
    public function setID($iD = null)
    {
        // validation for constraint: string
        if (!is_null($iD) && !is_string($iD)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($iD, true), gettype($iD)), __LINE__);
        }
        $this->ID = $iD;
        return $this;
    }
    /**
     * Get Name value
     * @return string|null
     */
    public function getName()
    {
        return $this->Name;
    }
    /**
     * Set Name value
     * @param string $name
     * @return \StructType\ServiceProviderType
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($name, true), gettype($name)), __LINE__);
        }
        $this->Name = $name;
        return $this;
    }
    /**
     * Get Town value
     * @return string|null
     */
    public function getTown()
    {
        return $this->Town;
    }
    /**
     * Set Town value
     * @param string $town
     * @return \StructType\ServiceProviderType
     */
    public function setTown($town = null)
    {
        // validation for constraint: string
        if (!is_null($town) && !is_string($town)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($town, true), gettype($town)), __LINE__);
        }
        $this->Town = $town;
        return $this;
    }
    /**
     * Get Code value
     * @return string|null
     */
    public function getCode()
    {
        return $this->Code;
    }
    /**
     * Set Code value
     * @param string $code
     * @return \StructType\ServiceProviderType
     */
    public function setCode($code = null)
    {
        // validation for constraint: string
        if (!is_null($code) && !is_string($code)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($code, true), gettype($code)), __LINE__);
        }
        $this->Code = $code;
        return $this;
    }
    /**
     * Get Email1 value
     * @return string|null
     */
    public function getEmail1()
    {
        return $this->Email1;
    }
    /**
     * Set Email1 value
     * @param string $email1
     * @return \StructType\ServiceProviderType
     */
    public function setEmail1($email1 = null)
    {
        // validation for constraint: string
        if (!is_null($email1) && !is_string($email1)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($email1, true), gettype($email1)), __LINE__);
        }
        $this->Email1 = $email1;
        return $this;
    }
    /**
     * Get Email2 value
     * @return string|null
     */
    public function getEmail2()
    {
        return $this->Email2;
    }
    /**
     * Set Email2 value
     * @param string $email2
     * @return \StructType\ServiceProviderType
     */
    public function setEmail2($email2 = null)
    {
        // validation for constraint: string
        if (!is_null($email2) && !is_string($email2)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($email2, true), gettype($email2)), __LINE__);
        }
        $this->Email2 = $email2;
        return $this;
    }
    /**
     * Get Phone value
     * @return string|null
     */
    public function getPhone()
    {
        return $this->Phone;
    }
    /**
     * Set Phone value
     * @param string $phone
     * @return \StructType\ServiceProviderType
     */
    public function setPhone($phone = null)
    {
        // validation for constraint: string
        if (!is_null($phone) && !is_string($phone)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($phone, true), gettype($phone)), __LINE__);
        }
        $this->Phone = $phone;
        return $this;
    }
    /**
     * Get Mobile value
     * @return string|null
     */
    public function getMobile()
    {
        return $this->Mobile;
    }
    /**
     * Set Mobile value
     * @param string $mobile
     * @return \StructType\ServiceProviderType
     */
    public function setMobile($mobile = null)
    {
        // validation for constraint: string
        if (!is_null($mobile) && !is_string($mobile)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($mobile, true), gettype($mobile)), __LINE__);
        }
        $this->Mobile = $mobile;
        return $this;
    }
    /**
     * Get Fax value
     * @return string|null
     */
    public function getFax()
    {
        return $this->Fax;
    }
    /**
     * Set Fax value
     * @param string $fax
     * @return \StructType\ServiceProviderType
     */
    public function setFax($fax = null)
    {
        // validation for constraint: string
        if (!is_null($fax) && !is_string($fax)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($fax, true), gettype($fax)), __LINE__);
        }
        $this->Fax = $fax;
        return $this;
    }
    /**
     * Get URL value
     * @return string|null
     */
    public function getURL()
    {
        return $this->URL;
    }
    /**
     * Set URL value
     * @param string $uRL
     * @return \StructType\ServiceProviderType
     */
    public function setURL($uRL = null)
    {
        // validation for constraint: string
        if (!is_null($uRL) && !is_string($uRL)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($uRL, true), gettype($uRL)), __LINE__);
        }
        $this->URL = $uRL;
        return $this;
    }
}
