<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for VTCategoryList StructType
 * @subpackage Structs
 */
class VTCategoryList extends AbstractStructBase
{
    /**
     * The VTCategory
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\VTCategoryType[]
     */
    public $VTCategory;
    /**
     * Constructor method for VTCategoryList
     * @uses VTCategoryList::setVTCategory()
     * @param \StructType\VTCategoryType[] $vTCategory
     */
    public function __construct(array $vTCategory = array())
    {
        $this
            ->setVTCategory($vTCategory);
    }
    /**
     * Get VTCategory value
     * @return \StructType\VTCategoryType[]|null
     */
    public function getVTCategory()
    {
        return $this->VTCategory;
    }
    /**
     * This method is responsible for validating the values passed to the setVTCategory method
     * This method is willingly generated in order to preserve the one-line inline validation within the setVTCategory method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateVTCategoryForArrayConstraintsFromSetVTCategory(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $vTCategoryListVTCategoryItem) {
            // validation for constraint: itemType
            if (!$vTCategoryListVTCategoryItem instanceof \StructType\VTCategoryType) {
                $invalidValues[] = is_object($vTCategoryListVTCategoryItem) ? get_class($vTCategoryListVTCategoryItem) : sprintf('%s(%s)', gettype($vTCategoryListVTCategoryItem), var_export($vTCategoryListVTCategoryItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The VTCategory property can only contain items of type \StructType\VTCategoryType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set VTCategory value
     * @throws \InvalidArgumentException
     * @param \StructType\VTCategoryType[] $vTCategory
     * @return \StructType\VTCategoryList
     */
    public function setVTCategory(array $vTCategory = array())
    {
        // validation for constraint: array
        if ('' !== ($vTCategoryArrayErrorMessage = self::validateVTCategoryForArrayConstraintsFromSetVTCategory($vTCategory))) {
            throw new \InvalidArgumentException($vTCategoryArrayErrorMessage, __LINE__);
        }
        $this->VTCategory = $vTCategory;
        return $this;
    }
    /**
     * Add item to VTCategory value
     * @throws \InvalidArgumentException
     * @param \StructType\VTCategoryType $item
     * @return \StructType\VTCategoryList
     */
    public function addToVTCategory(\StructType\VTCategoryType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\VTCategoryType) {
            throw new \InvalidArgumentException(sprintf('The VTCategory property can only contain items of type \StructType\VTCategoryType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->VTCategory[] = $item;
        return $this;
    }
}
