<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for VTCountryList StructType
 * @subpackage Structs
 */
class VTCountryList extends AbstractStructBase
{
    /**
     * The VTCountry
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\VTCountryType[]
     */
    public $VTCountry;
    /**
     * Constructor method for VTCountryList
     * @uses VTCountryList::setVTCountry()
     * @param \StructType\VTCountryType[] $vTCountry
     */
    public function __construct(array $vTCountry = array())
    {
        $this
            ->setVTCountry($vTCountry);
    }
    /**
     * Get VTCountry value
     * @return \StructType\VTCountryType[]|null
     */
    public function getVTCountry()
    {
        return $this->VTCountry;
    }
    /**
     * This method is responsible for validating the values passed to the setVTCountry method
     * This method is willingly generated in order to preserve the one-line inline validation within the setVTCountry method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateVTCountryForArrayConstraintsFromSetVTCountry(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $vTCountryListVTCountryItem) {
            // validation for constraint: itemType
            if (!$vTCountryListVTCountryItem instanceof \StructType\VTCountryType) {
                $invalidValues[] = is_object($vTCountryListVTCountryItem) ? get_class($vTCountryListVTCountryItem) : sprintf('%s(%s)', gettype($vTCountryListVTCountryItem), var_export($vTCountryListVTCountryItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The VTCountry property can only contain items of type \StructType\VTCountryType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set VTCountry value
     * @throws \InvalidArgumentException
     * @param \StructType\VTCountryType[] $vTCountry
     * @return \StructType\VTCountryList
     */
    public function setVTCountry(array $vTCountry = array())
    {
        // validation for constraint: array
        if ('' !== ($vTCountryArrayErrorMessage = self::validateVTCountryForArrayConstraintsFromSetVTCountry($vTCountry))) {
            throw new \InvalidArgumentException($vTCountryArrayErrorMessage, __LINE__);
        }
        $this->VTCountry = $vTCountry;
        return $this;
    }
    /**
     * Add item to VTCountry value
     * @throws \InvalidArgumentException
     * @param \StructType\VTCountryType $item
     * @return \StructType\VTCountryList
     */
    public function addToVTCountry(\StructType\VTCountryType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\VTCountryType) {
            throw new \InvalidArgumentException(sprintf('The VTCountry property can only contain items of type \StructType\VTCountryType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->VTCountry[] = $item;
        return $this;
    }
}
