<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for VTServiceProviderList StructType
 * @subpackage Structs
 */
class VTServiceProviderList extends AbstractStructBase
{
    /**
     * The ServiceProvider
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\VTServiceProviderType[]
     */
    public $ServiceProvider;
    /**
     * Constructor method for VTServiceProviderList
     * @uses VTServiceProviderList::setServiceProvider()
     * @param \StructType\VTServiceProviderType[] $serviceProvider
     */
    public function __construct(array $serviceProvider = array())
    {
        $this
            ->setServiceProvider($serviceProvider);
    }
    /**
     * Get ServiceProvider value
     * @return \StructType\VTServiceProviderType[]|null
     */
    public function getServiceProvider()
    {
        return $this->ServiceProvider;
    }
    /**
     * This method is responsible for validating the values passed to the setServiceProvider method
     * This method is willingly generated in order to preserve the one-line inline validation within the setServiceProvider method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateServiceProviderForArrayConstraintsFromSetServiceProvider(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $vTServiceProviderListServiceProviderItem) {
            // validation for constraint: itemType
            if (!$vTServiceProviderListServiceProviderItem instanceof \StructType\VTServiceProviderType) {
                $invalidValues[] = is_object($vTServiceProviderListServiceProviderItem) ? get_class($vTServiceProviderListServiceProviderItem) : sprintf('%s(%s)', gettype($vTServiceProviderListServiceProviderItem), var_export($vTServiceProviderListServiceProviderItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ServiceProvider property can only contain items of type \StructType\VTServiceProviderType, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ServiceProvider value
     * @throws \InvalidArgumentException
     * @param \StructType\VTServiceProviderType[] $serviceProvider
     * @return \StructType\VTServiceProviderList
     */
    public function setServiceProvider(array $serviceProvider = array())
    {
        // validation for constraint: array
        if ('' !== ($serviceProviderArrayErrorMessage = self::validateServiceProviderForArrayConstraintsFromSetServiceProvider($serviceProvider))) {
            throw new \InvalidArgumentException($serviceProviderArrayErrorMessage, __LINE__);
        }
        $this->ServiceProvider = $serviceProvider;
        return $this;
    }
    /**
     * Add item to ServiceProvider value
     * @throws \InvalidArgumentException
     * @param \StructType\VTServiceProviderType $item
     * @return \StructType\VTServiceProviderList
     */
    public function addToServiceProvider(\StructType\VTServiceProviderType $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\VTServiceProviderType) {
            throw new \InvalidArgumentException(sprintf('The ServiceProvider property can only contain items of type \StructType\VTServiceProviderType, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ServiceProvider[] = $item;
        return $this;
    }
}
