<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for VTServiceProviderType StructType
 * @subpackage Structs
 */
class VTServiceProviderType extends AbstractStructBase
{
    /**
     * The Name
     * @var string
     */
    public $Name;
    /**
     * The Code
     * @var string
     */
    public $Code;
    /**
     * The ID
     * @var string
     */
    public $ID;
    /**
     * The CommunityName
     * @var string
     */
    public $CommunityName;
    /**
     * The CommunityID
     * @var string
     */
    public $CommunityID;
    /**
     * Constructor method for VTServiceProviderType
     * @uses VTServiceProviderType::setName()
     * @uses VTServiceProviderType::setCode()
     * @uses VTServiceProviderType::setID()
     * @uses VTServiceProviderType::setCommunityName()
     * @uses VTServiceProviderType::setCommunityID()
     * @param string $name
     * @param string $code
     * @param string $iD
     * @param string $communityName
     * @param string $communityID
     */
    public function __construct($name = null, $code = null, $iD = null, $communityName = null, $communityID = null)
    {
        $this
            ->setName($name)
            ->setCode($code)
            ->setID($iD)
            ->setCommunityName($communityName)
            ->setCommunityID($communityID);
    }
    /**
     * Get Name value
     * @return string|null
     */
    public function getName()
    {
        return $this->Name;
    }
    /**
     * Set Name value
     * @param string $name
     * @return \StructType\VTServiceProviderType
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($name, true), gettype($name)), __LINE__);
        }
        $this->Name = $name;
        return $this;
    }
    /**
     * Get Code value
     * @return string|null
     */
    public function getCode()
    {
        return $this->Code;
    }
    /**
     * Set Code value
     * @param string $code
     * @return \StructType\VTServiceProviderType
     */
    public function setCode($code = null)
    {
        // validation for constraint: string
        if (!is_null($code) && !is_string($code)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($code, true), gettype($code)), __LINE__);
        }
        $this->Code = $code;
        return $this;
    }
    /**
     * Get ID value
     * @return string|null
     */
    public function getID()
    {
        return $this->ID;
    }
    /**
     * Set ID value
     * @param string $iD
     * @return \StructType\VTServiceProviderType
     */
    public function setID($iD = null)
    {
        // validation for constraint: string
        if (!is_null($iD) && !is_string($iD)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($iD, true), gettype($iD)), __LINE__);
        }
        $this->ID = $iD;
        return $this;
    }
    /**
     * Get CommunityName value
     * @return string|null
     */
    public function getCommunityName()
    {
        return $this->CommunityName;
    }
    /**
     * Set CommunityName value
     * @param string $communityName
     * @return \StructType\VTServiceProviderType
     */
    public function setCommunityName($communityName = null)
    {
        // validation for constraint: string
        if (!is_null($communityName) && !is_string($communityName)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($communityName, true), gettype($communityName)), __LINE__);
        }
        $this->CommunityName = $communityName;
        return $this;
    }
    /**
     * Get CommunityID value
     * @return string|null
     */
    public function getCommunityID()
    {
        return $this->CommunityID;
    }
    /**
     * Set CommunityID value
     * @param string $communityID
     * @return \StructType\VTServiceProviderType
     */
    public function setCommunityID($communityID = null)
    {
        // validation for constraint: string
        if (!is_null($communityID) && !is_string($communityID)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($communityID, true), gettype($communityID)), __LINE__);
        }
        $this->CommunityID = $communityID;
        return $this;
    }
}
